// Chrono68k v0.51
// CopyLeft by Jonas Gehring & Ilidio Martins

// C Source File
// Created 17.11.04; 14:50:30


#include <graph.h>						// Common (non-windowed) graphic routines
#include <stdio.h>						// ANSI-compatible file and TTY input/output routines
#include <system.h>						// System routines (for accessing system timers, queues, etc.)
#include <compat.h>						// Various calc-dependent and AMS-dependent pseudo-constants
#include <kbd.h>							// Keyboard handling routines
#include <asmtypes.h>					// Common type definitions known to ASM programmers
//#include <ctype.h>						// Routines for checking and changing character types
#include <stdlib.h>						// Some useful routines proposed by ANSI (sorting, searching, etc.)

#include "unknown.h"					// I modified this file to accept the new TIClock options

#include "extgraph.h"					// Include ExtGraph Library v2.00beta3 by TI-Chess Team

#include "chrono68k.h"


// Draws the menu
void DrawMenu(BOOL mode)
{
	// Draw the box
	GrayDrawRect((LCD_WIDTH/2)-57, (LCD_HEIGHT/2)-34, (LCD_WIDTH/2)+59, (LCD_HEIGHT/2)+36, COLOR_LIGHTGRAY, RECT_EMPTY);
	GrayDrawRect((LCD_WIDTH/2)-58, (LCD_HEIGHT/2)-35, (LCD_WIDTH/2)+58, (LCD_HEIGHT/2)+35, COLOR_BLACK, RECT_FILLED);
	
	// Draw the title
	GrayDrawStrExt(0, (LCD_HEIGHT/2)-33, "Chrono68k", A_XOR | A_CENTERED | A_SHADOWED, F_6x8);
	GrayFastDrawLine((LCD_WIDTH/2)-32, (LCD_HEIGHT/2)-23, (LCD_WIDTH/2)+32, (LCD_HEIGHT/2)-23, COLOR_LIGHTGRAY);
		
	if (!mode)
		return;

	// Draw the options
	GrayDrawStrExt((LCD_WIDTH/2-41), (LCD_HEIGHT/2)-17, "Set Display Format", A_XOR, F_4x6);
	GrayDrawStrExt((LCD_WIDTH/2-41), (LCD_HEIGHT/2)-7,  "Set Time", A_XOR, F_4x6);
	GrayDrawStrExt((LCD_WIDTH/2-41), (LCD_HEIGHT/2)+3,  "About", A_XOR, F_4x6);
	GrayDrawStrExt((LCD_WIDTH/2-41), (LCD_HEIGHT/2)+13, "Return to Chrono68k", A_XOR, F_4x6);
	GrayDrawStrExt((LCD_WIDTH/2-41), (LCD_HEIGHT/2)+23, "Exit Chrono68k", A_XOR, F_4x6);
}


// The AboutScreen
void AboutScreen(void)
{
	DrawMenu(FALSE);
	
	GrayDrawStrExt(0, (LCD_HEIGHT/2)-20, VERSION, A_XOR | A_CENTERED, F_4x6);
	GrayDrawStrExt(0, (LCD_HEIGHT/2)-10, "Jonas Gehring", A_XOR | A_CENTERED, F_6x8);
	GrayDrawStrExt(0, (LCD_HEIGHT/2), "and", A_XOR | A_CENTERED, F_4x6);
	GrayDrawStrExt(0, (LCD_HEIGHT/2)+8, "Ilidio Martins", A_XOR | A_CENTERED, F_6x8);
	GrayDrawStrExt(0, (LCD_HEIGHT/2)+25, "powered by ExtGraph", A_XOR | A_CENTERED, F_4x6);
	
	while (!_keytest(RR_ENTER) && !_keytest(RR_ENTER2));
	
	ClearQueue();
}


// Sets the actual time of the TIClock
void SetTime(void)
{
	INT_HANDLER save_gray_1 = GrayGetInt1Handler();

	GraySetInt1Handler(save_int_1);
	
	GrayOff();
	
	// This time, we'll make it easy... :)	
	DateAndTime_SetDlg();
	
	if (!GrayOn())
		exit(0);
	
	GraySetInt1Handler(save_gray_1);

	
	/*short pos = 0, post, key;
	short posy = 0;
	signed short tstr1 = -1, tstr2 = -1;
	short date[6];
	short nsec, nmin, nhour;
	short *var = NULL;
	void *kbq = kbd_queue();
	INT_HANDLER save_gray_1 = GrayGetInt1Handler();

	GraySetInt1Handler(save_int_1);

	FontSetSys(F_4x6);

	// Get old time
	DateAndTime_Get(&date[0], &date[1], &date[2], &date[3], &date[4], &date[5]);

	restart:

	// Draw the Box and the requests
	DrawMenu(FALSE);
	GrayDrawStr((LCD_WIDTH/2-42), (LCD_HEIGHT/2)-16, "Year:      ", A_XOR);
	GrayDrawStr((LCD_WIDTH/2-42), (LCD_HEIGHT/2)-8,  "Month:     ", A_XOR);
	GrayDrawStr((LCD_WIDTH/2-42), (LCD_HEIGHT/2),    "Day:       ", A_XOR);
	
	GrayDrawStr((LCD_WIDTH/2-42), (LCD_HEIGHT/2)+8,  "Hours:     ", A_XOR);
	GrayDrawStr((LCD_WIDTH/2-42), (LCD_HEIGHT/2)+16, "Minutes:   ", A_XOR);
	GrayDrawStr((LCD_WIDTH/2-42), (LCD_HEIGHT/2)+24, "Seconds:   ", A_XOR);
	
	do {
		post = pos;
		
		while (OSdequeue(&key, kbq)) continue;	// Get a keypress
		key = key & 0xf7ff;											// Mask out the repeat flag
		
		// Enter new values
		if (pos < 2 && isdigit(key)) {
			if (!pos)
				tstr1 = key-48;
			else
				tstr2 = key-48;
			GrayDrawChar((LCD_WIDTH/2)+6+(pos*4), (LCD_HEIGHT/2)-16+(posy*8), key, A_XOR);
			pos++;
		}
		
		// Store new values
		else if (key == KEY_ENTER && tstr1 > -1) {
			var = &date[pos];
			
			if (tstr2 == -1)
				*var = tstr1; 
			else
				*var = tstr1*10 + tstr2;
		
			if (posy < 5) {
				posy++;
				pos = 0;
				tstr1 = -1; tstr2 = -1;
			} else if (posy == 2)
					break;
		}
		
		else if (key == KEY_ESC)
			goto interrupt;
		
	}	while (TRUE);
	
	// Set the new time
	if (date[0] < 31 && date[1] < )
		DateAndTime_Set(&date[0], &date[1], &date[2], &date[3], &date[4], &date[5]);
	else
		goto restart;
	
	interrupt:
	ClearQueue();
	GraySetInt1Handler(save_gray_1);*/
}


// The menu
BOOL Menu(void)
{
	short opt = 0, optt;

	DrawMenu(TRUE);

	GrayDrawStrExt((LCD_WIDTH/2-55), (LCD_HEIGHT/2)-17+(opt*10), "-", A_XOR, F_4x6);
	
	do {
		optt = opt;
		
		// Choose between the options
		if (_keytest(RR_DOWN) && opt < 4) {
			 ClearQueue();
			 opt++;
		}
		if (_keytest(RR_UP) && opt > 0) {
			 ClearQueue();
			 opt--;
		}
		
		// Quit the menu
		if (_keytest(RR_ESC)) {
			ClearQueue();
			return TRUE;
		}
		
		// Select an option
		if (_keytest(RR_ENTER) || _keytest(RR_ENTER2)) {
			ClearQueue();
			switch (opt) {
				case 0:SetTimeFormat();
								break;
				case 1:SetTime();
								break;
				case 2:AboutScreen();
								break;
				case 3:return TRUE;
								break;
				case 4:return FALSE;
								break;
				
				default:
								break;
			}
			DrawMenu(TRUE);
			GrayDrawStrExt((LCD_WIDTH/2-55), (LCD_HEIGHT/2)-17+(opt*10), "-", A_XOR, F_4x6);			
		}
		
		// Redraw cursor
		if (opt != optt) {
			GrayDrawStrExt((LCD_WIDTH/2-55), (LCD_HEIGHT/2)-17+(optt*10), "-", A_XOR, F_4x6);
			GrayDrawStrExt((LCD_WIDTH/2-55), (LCD_HEIGHT/2)-17+(opt*10), "-", A_XOR, F_4x6);
		}
		
	} while (TRUE);
}